
def loadFasta(filename):

    f=open(filename)
    seqs={}
    name=""
    sequence=""
    for row in f.readlines():
        if row[0] == '>':
            if name:
                seqs[name] = sequence
                name=""
                sequence=""
            name=row[1:].strip()
        else:
            sequence+=row
    if name:
        seqs[name] = sequence

    f.close()
    return seqs
    

def commonStarts(seqs, seed):
    starts={}
    for (name,seq) in seqs.items():
        end=-1
        for i in range(len(seed)):
            if len(seq) <= i or seed[i] != seq[i]:
                end=i-1
                break
        if end >= 0:
            starts[name]=seq[0:end+1]
    return starts

def printDict(starts):
    for (name,start) in starts.items():
        print(name + "\t" + start)

def findCommonStarts(filename, seed):
    seqs=loadFasta(filename)
    starts=commonStarts(seqs, seed)
    printDict(starts)
