def loadBindings(filename):
    f=open(filename)
    f.readline() # header
    bindings=[]

    for row in f.readlines():
        data = row.split()
        gene_name=data[1]
        reg_name=data[6]
        bind_start=int(data[8])
        bind_end=int(data[9])
        bindings.append((gene_name,reg_name,bind_start,bind_end))
    
    f.close()
    return bindings

def bindings2dicts(bindings):
    gene_dict={}
    reg_dict={}
    
    for (gene_name,reg_name,bind_start,bind_end) in bindings:
        if not gene_dict.has_key(gene_name):
            gene_dict[gene_name]=[]
        gene_dict[gene_name].append((bind_start,bind_end))
        if not reg_dict.has_key(reg_name):
            reg_dict[reg_name]=[]
        reg_dict[reg_name].append((bind_start,bind_end))
    return gene_dict,reg_dict

def RegulatoryStats(bind_dict):
    for (name,bind_list) in bind_dict.items():
        num_binds=len(bind_list)
        avg_length=0.
        for (start,end) in bind_list:
            avg_length+=end-start+1
        avg_length/=num_binds
        print "%s\t%d\t%.2f" % (name,num_binds,avg_length)

def computeBindingStats(filename):
    bindings=loadBindings(filename)
    gene_dict,reg_dict = bindings2dicts(bindings)
    print "reg_name\tnum_binds\tavg_length"
    RegulatoryStats(reg_dict)
    print "gene_name\tnum_binds\tavg_length"
    RegulatoryStats(gene_dict)

computeBindingStats('bindings.txt')
